# L'interactivité offre de nouvelles possibilités

Aujourd'hui, des fonctionalités intéressantes sont offertes par les documents numériques interactifs. Elles sont difficiles à circonscrire, les applications étant quasiment infinies. Je vous propose de faire appel a votre imagination: imaginez un roman policier dont l'histoire s'adapte en fonction des choix du lecteur. Imaginez un guide de voyage qui se tient à jour (horaires d'ouvertures, prix, etc. ). Imaginez encore un livre de nutrition, offrant la possibilité de comparer graphiquement les qualités de plusieurs mets de son choix. Imaginez des livres de cours permettant de tester pratiquement ou de simuler les théories qu'ils présentent. Imaginez finalement une analyse scientifique qui affine ses résultats à mesure que les données disponibles sur le phénomène étudié s'étoffent. 

Tout cela est d'ores et déjà possible. Et ce n'est pas nouveau. Déjà dans les années 1980, les logiciels [Maple](http://www.maplesoft.com/products/maple/) et [Mathematica](https://www.wolfram.com/mathematica/) proposent un format de Notebook interactif. Cependant, ces logiciels ne sont pas libres, sont fortement orientés mathématiques et ne présentent donc que peu d'intérêt pour le majorité des utilisateurs.

Les Notebooks discutés dans cet article sont issus du projet IPython datant de 2001. Il s'agit d'un terminal interactif construit autour du langage Python et facilitant le travail interactif avec celui-ci. De fil en aiguille, une interface web a été développée pour IPython: les IPython Notebooks. Vu la flexibilité de l'outil, des communautés travaillant sur d'autres langages de programmation ont été attirées par cette interface, et des noyaux pour supporter plus de 50 langages ont été créés, y compris Maple et Mathematica. En 2014, la communauté de développement s'est séparée en deux: une équipe se focalise sur le développement du noyau IPython et une autre sur l'interface renommée Jupyter.  