# Les limites

Présentés comme cela, les notebooks ont beaucoup de potentiel... où est le piège?

La rédaction "classique", autrement dit les cellules de texte (titres, sous-titres, paragraphes, liens web, listes à points, tableaux, images, vidéos, et formules mathématiques), se fait principalement en Markdown. Ceci nécessite un apprentissage. Heureusement, le Markdown s'apprend en une dizaine de minutes et constitue un bon investissement, car ce langage est de plus en plus répandu (par exemple supporté par Authorea, GitHub, Zenodo et [Nature Publishing Group](http://www.nature.com/news/interactive-notebooks-sharing-the-code-1.16261)). Il s'agit d'un langage de balisage léger, conçu pour être facile à lire et à rédiger. En voici les éléments principaux:
- pour créer un titre, faire précéder la ligne d'un dièse (Exemple: `# Ceci est un titre`)
- pour mettre un texte en *italique*, l'entourer d'astérisques (Exemple: `Ce *mot* sera affiché en italique.`)
- pour mettre un texte en **gras**, l'entourer de doubles astérisques (Exemple: `Ce **mot** sera affiché en gras.`)
- pour produire une liste, faire débuter chaque point par un tiret (Exemple: `- Ceci est un point dans une liste`)
- pour placer un lien sur du texte, utiliser la syntaxe: `[Jupyter Notebooks](http://jupyter.org)`
- pour insérer une image, utiliser la syntaxe: `![Logo Jupyter](http://jupyter.org/assets/main-logo.svg)`.

Voilà, vous connaissez l'essentiel du Markdown. Par ailleurs, celui-ci permet également de créer des listes numérotées et des tableaux. Le Markdown permet donc de rédiger la plupart des document (par exemple celui-ci). Pour des formatages plus poussés Jupyter permet de compléter le Markdown par du HTML et/ou du LaTeX.

Concernant la rédaction des parties dynamiques, autrement dit les cellules de code, plusieurs options sont disponibles, notamment le langage Python, mais par exemple aussi R, PHP, Perl, JavaScript, Julia, Scala, Spark, Ruby. Cela peut paraître très complexe, mais de nombreuses fonctions simplifiées sont disponibles. Voyons par exemple comment insérer une vidéo de YouTube en Python:

    from IPython.display import YouTubeVideo
    YouTubeVideo("Pi9NpxAvYSs")


